'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../../../consumer/component/components-list'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _models;

function _load_models() {
  return _models = require('../../../scope/models');
}

var _analytics;

function _load_analytics() {
  return _analytics = require('../../../analytics/analytics');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
    var consumer, componentsList, newAndImportPendingComponents, newComponents, importPendingComponents, modifiedComponent, stagedComponents, autoTagPendingComponents, autoTagPendingComponentsStr, deletedComponents, deletedComponentsStr, outdatedComponents, newAndModified, componentsWithMissingDeps;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context.sent;
            componentsList = new (_componentsList || _load_componentsList()).default(consumer);
            _context.next = 6;
            return componentsList.listNewComponentsAndImportPending();

          case 6:
            newAndImportPendingComponents = _context.sent;
            newComponents = newAndImportPendingComponents.newComponents, importPendingComponents = newAndImportPendingComponents.importPendingComponents;
            _context.next = 10;
            return componentsList.listModifiedComponents(true);

          case 10:
            modifiedComponent = _context.sent;
            _context.next = 13;
            return componentsList.listExportPendingComponents(true);

          case 13:
            stagedComponents = _context.sent;
            _context.next = 16;
            return componentsList.listAutoTagPendingComponents();

          case 16:
            autoTagPendingComponents = _context.sent;
            autoTagPendingComponentsStr = autoTagPendingComponents.map(function (component) {
              return component.id().toString();
            });
            _context.next = 20;
            return componentsList.listDeletedComponents();

          case 20:
            deletedComponents = _context.sent;
            deletedComponentsStr = deletedComponents.map(function (component) {
              return component.toString();
            });
            _context.next = 24;
            return componentsList.listOutdatedComponents();

          case 24:
            outdatedComponents = _context.sent;


            // Run over the components to check if there is missing dependencies
            // If there is at least one we won't commit anything
            newAndModified = newComponents.concat(modifiedComponent);
            componentsWithMissingDeps = newAndModified.filter(function (component) {
              return Boolean(component.missingDependencies);
            });

            (_analytics || _load_analytics()).Analytics.setExtraData('new_components', newComponents.length);
            (_analytics || _load_analytics()).Analytics.setExtraData('staged_components', stagedComponents.length);
            (_analytics || _load_analytics()).Analytics.setExtraData('num_components_with_missing_dependencies', componentsWithMissingDeps.length);
            (_analytics || _load_analytics()).Analytics.setExtraData('autoTagPendingComponents', autoTagPendingComponents.length);
            (_analytics || _load_analytics()).Analytics.setExtraData('deleted', deletedComponents.length);
            _context.next = 34;
            return consumer.onDestroy();

          case 34:
            return _context.abrupt('return', {
              newComponents: (_componentsList || _load_componentsList()).default.sortComponentsByName(newComponents),
              modifiedComponent: (_componentsList || _load_componentsList()).default.sortComponentsByName(modifiedComponent),
              stagedComponents: (_componentsList || _load_componentsList()).default.sortComponentsByName(stagedComponents),
              componentsWithMissingDeps, // no need to sort, we don't print it as is
              importPendingComponents, // no need to sort, we use only its length
              autoTagPendingComponents: (_componentsList || _load_componentsList()).default.sortComponentsByName(autoTagPendingComponentsStr),
              deletedComponents: (_componentsList || _load_componentsList()).default.sortComponentsByName(deletedComponentsStr),
              outdatedComponents
            });

          case 35:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function status() {
    return _ref.apply(this, arguments);
  }

  return status;
}();