'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _mergeCmd;

function _load_mergeCmd() {
  return _mergeCmd = require('./merge-cmd');
}

var _mergeVersion;

function _load_mergeVersion() {
  return _mergeVersion = require('../../../consumer/versions-ops/merge-version');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkout = function (_Command) {
  _inherits(Checkout, _Command);

  function Checkout() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Checkout);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Checkout.__proto__ || Object.getPrototypeOf(Checkout)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'checkout <version> <ids...>', _this.description = 'switch between component versions', _this.alias = 'U', _this.opts = [['i', 'interactive-merge', 'when a component is modified and the merge process found conflicts, display options to resolve them'], ['o', 'ours', 'in case of a conflict, override the used version with the current modification'], ['t', 'theirs', 'in case of a conflict, override the current modification with the specified version'], ['m', 'manual', 'in case of a conflict, leave the files with a conflict state to resolve them manually later'], ['v', 'verbose', 'showing verbose output for inspection'], ['', 'skip-npm-install', 'do not install packages of the imported components'], ['', 'ignore-dist', 'do not write dist files (when exist)']], _this.loader = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Checkout, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 2),
          version = _ref4[0],
          ids = _ref4[1];

      var _ref3$interactiveMerg = _ref3.interactiveMerge,
          interactiveMerge = _ref3$interactiveMerg === undefined ? false : _ref3$interactiveMerg,
          _ref3$ours = _ref3.ours,
          ours = _ref3$ours === undefined ? false : _ref3$ours,
          _ref3$theirs = _ref3.theirs,
          theirs = _ref3$theirs === undefined ? false : _ref3$theirs,
          _ref3$manual = _ref3.manual,
          manual = _ref3$manual === undefined ? false : _ref3$manual,
          _ref3$verbose = _ref3.verbose,
          verbose = _ref3$verbose === undefined ? false : _ref3$verbose,
          _ref3$skipNpmInstall = _ref3.skipNpmInstall,
          skipNpmInstall = _ref3$skipNpmInstall === undefined ? false : _ref3$skipNpmInstall,
          _ref3$ignoreDist = _ref3.ignoreDist,
          ignoreDist = _ref3$ignoreDist === undefined ? false : _ref3$ignoreDist;

      var bitIds = ids.map(function (id) {
        return (_bitId || _load_bitId()).BitId.parse(id);
      });
      var checkoutProps = {
        version,
        ids: bitIds,
        promptMergeOptions: interactiveMerge,
        mergeStrategy: (0, (_mergeVersion || _load_mergeVersion()).getMergeStrategy)(ours, theirs, manual),
        verbose,
        skipNpmInstall,
        ignoreDist
      };
      return (0, (_consumer || _load_consumer()).checkout)(checkoutProps);
    }
  }, {
    key: 'report',
    value: function report(_ref5) {
      var components = _ref5.components,
          version = _ref5.version;

      if (components.length === 1) {
        var componentName = components[0].id.toStringWithoutVersion();
        var _title = `successfully switched ${(_chalk || _load_chalk()).default.bold(componentName)} to version ${(_chalk || _load_chalk()).default.bold(version)}\n`;
        return `${_title} ${(0, (_mergeCmd || _load_mergeCmd()).applyVersionReport)(components, false)}`;
      }

      var title = `successfully switched the selected component(s) to version ${(_chalk || _load_chalk()).default.bold(version)}\n\n`;
      var componentsStr = (0, (_mergeCmd || _load_mergeCmd()).applyVersionReport)(components);
      return `${title} ${componentsStr}`;
    }
  }]);

  return Checkout;
}((_command || _load_command()).default);

exports.default = Checkout;