'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Login = function (_Command) {
  _inherits(Login, _Command);

  function Login() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Login);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Login.__proto__ || Object.getPrototypeOf(Login)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'login', _this.description = 'log the CLI into Bit', _this.alias = '', _this.opts = [['p', 'port <port>', 'port number to open for localhost server (default 8085)'], ['', 'no-launch-browser', 'do not open a browser for authentication'], ['', 'npmrc-path <path>', 'path to npmrc file to configure bitsrc registry'], ['', 'skip-registry-config [boolean]', 'dont configure bitsrc registry']], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Login, [{
    key: 'action',

    // $FlowFixMe
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          nothing = _ref4[0];

      var port = _ref3.port,
          _ref3$noLaunchBrowser = _ref3.noLaunchBrowser,
          noLaunchBrowser = _ref3$noLaunchBrowser === undefined ? false : _ref3$noLaunchBrowser,
          npmrcPath = _ref3.npmrcPath,
          _ref3$skipRegistryCon = _ref3.skipRegistryConfig,
          skipRegistryConfig = _ref3$skipRegistryCon === undefined ? false : _ref3$skipRegistryCon;

      return (0, (_consumer || _load_consumer()).login)(port, noLaunchBrowser, npmrcPath, skipRegistryConfig).then(function (_ref5) {
        var isAlreadyLoggedIn = _ref5.isAlreadyLoggedIn,
            username = _ref5.username,
            npmrcPath = _ref5.npmrcPath,
            writeToNpmrcError = _ref5.writeToNpmrcError;
        return {
          isAlreadyLoggedIn,
          username,
          npmrcPath,
          writeToNpmrcError,
          skipRegistryConfig
        };
      });
    }
  }, {
    key: 'report',
    value: function report(_ref6) {
      var _ref6$isAlreadyLogged = _ref6.isAlreadyLoggedIn,
          isAlreadyLoggedIn = _ref6$isAlreadyLogged === undefined ? false : _ref6$isAlreadyLogged,
          username = _ref6.username,
          npmrcPath = _ref6.npmrcPath,
          skipRegistryConfig = _ref6.skipRegistryConfig,
          writeToNpmrcError = _ref6.writeToNpmrcError;

      if (isAlreadyLoggedIn) return (_chalk || _load_chalk()).default.yellow('already logged in');
      var successLoginMessage = (_chalk || _load_chalk()).default.green(`success! logged in as ${username}`);
      var writeToNpmrcMessage = '\n';
      if (!skipRegistryConfig) {
        writeToNpmrcMessage = writeToNpmrcError ? (_chalk || _load_chalk()).default.yellow(`\nunable to add @bit as a scoped registry at "${(_chalk || _load_chalk()).default.bold(npmrcPath)}"\n`) : (_chalk || _load_chalk()).default.green(`\nsuccessfully added @bit as a scoped registry at ${npmrcPath}\n`);
      }
      var finalMessage = `${writeToNpmrcMessage}${successLoginMessage}`;
      return finalMessage;
    }
  }]);

  return Login;
}((_command || _load_command()).default);

exports.default = Login;