'use strict';

var _replaceBufferNonRecursive;

function _load_replaceBufferNonRecursive() {
  return _replaceBufferNonRecursive = _interopRequireDefault(require('./buffer/replace-buffer-non-recursive'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isWindows = typeof process !== 'undefined' && process.platform === 'win32';

var lineBreak = isWindows ? '\r\n' : '\n';
var newLines = ['\r\n', '\r', '\n'];
var newline = /\r\n|\r|\n/g;

function converts(text, to) {
  if (Buffer.isBuffer(text)) {
    newLines.forEach(function (newLine) {
      // $FlowFixMe text is Buffer here
      if (newLine !== to) text = (0, (_replaceBufferNonRecursive || _load_replaceBufferNonRecursive()).default)(text, newLine, to);
    });
    return text;
  }
  return text.toString().replace(newline, to);
}

exports.lf = function (text) {
  return converts(text, '\n');
};

exports.auto = function (text) {
  return converts(text, lineBreak);
};

exports.cr = function (text) {
  return converts(text, '\r');
};

exports.crlf = function (text) {
  return converts(text, '\r\n');
};